=== modified file 'INDEX'
--- INDEX	2015-06-06 05:17:11 +0000
+++ INDEX	2015-07-18 20:54:25 +0000
@@ -100,8 +100,11 @@
     hello_world:
         quick example to help test if flashing hardware works
 
+    odd/MGdriver:
+        Off-time multigroup driver by odd, based on luxdrv030 by DrJones
+
     pilotdog68/xintd-x3:
-        XinTD X3 FET+1 firmware supporting both Li-Ion and 3xAA batteries
+        XinTD X3 FET+1 firmware supporting both li-ion and 3xAA batteries
 
     tterev3/attiny10_starter_code:
         attiny10 starter example
@@ -124,6 +127,7 @@
         DrJones/NLITE
         DrJones/heartbeat
         DrJones/luxdrv
+        odd/MGdriver
 
     JonnyC:
         JonnyC/STAR/MTN_momentary_temp
@@ -172,6 +176,9 @@
     dthoang:
         dthoang
 
+    odd:
+        odd/MGdriver
+
     pilotdog68:
         pilotdog68/xintd-x3
 
@@ -205,6 +212,7 @@
         Werner/STAR_improvements
         _the_/TheStar
         alexvh/basic_off_time_driver
+        odd/MGdriver
         pilotdog68/xintd-x3
         tterev3/pic10f322-examples
         tterev3/power_cycle_light
@@ -262,6 +270,7 @@
 
     mode groups:
         ToyKeeper/blf-a6
+        odd/MGdriver
         pilotdog68/xintd-x3
 
     offtime-3:
@@ -346,6 +355,7 @@
         _the_/TheStar
         alexvh/basic_off_time_driver
         dthoang
+        odd/MGdriver
         pilotdog68/xintd-x3
 
     pic10f322:
@@ -388,6 +398,7 @@
         Werner/STAR_improvements
         alexvh/basic_off_time_driver
         dthoang
+        odd/MGdriver
 
     offtime:
         JonnyC/STAR/STAR_off_time
@@ -401,6 +412,7 @@
         Werner/STAR_improvements
         _the_/TheStar
         alexvh/basic_off_time_driver
+        odd/MGdriver
         pilotdog68/xintd-x3
         tterev3/pic10f322-examples
 
@@ -467,6 +479,7 @@
         ToyKeeper/tail-light
         ToyKeeper/uv
         _the_/TheStar
+        odd/MGdriver
         tterev3/power_cycle_light
 
     bike flasher:
@@ -516,6 +529,7 @@
 
     strobe:
         Tamagotchi/7135x8v2
+        odd/MGdriver
 
     tactical strobe:
         DrJones/luxdrv

=== added directory 'odd'
=== added directory 'odd/MGdriver'
=== added file 'odd/MGdriver/MGdriver.c'
--- odd/MGdriver/MGdriver.c	1970-01-01 00:00:00 +0000
+++ odd/MGdriver/MGdriver.c	2015-07-18 20:54:25 +0000
@@ -0,0 +1,251 @@
+/*
+ *
+ * MGdriver -  Off-time MultiGroup Driver by odd, based on luxdrv030 by DrJones
+ *
+ *
+ * License: CC-BY-NC-SA (non-commercial use only, derivative works must be under the same license)
+ *
+ *
+ *  Main differences to luxdrvß30:
+ *  - REMOVED: Ramping mode
+ *  - REMOVED: Wear leveling
+ *  - CHANGED: OFFTime memory instead of ONTime memory
+ *  - ADDED: Multiple groups
+ *  - ADDED: Memory or nomemory selectable for each group
+ *  - ADDED: Simple UI for switching groups
+ */
+
+
+#include <avr/pgmspace.h>
+#include <avr/io.h>
+#include <util/delay_basic.h>
+#include <avr/interrupt.h>
+#include <avr/sleep.h>
+#include <avr/eeprom.h>
+
+#define F_CPU 			4800000
+#define byte 			uint8_t
+#define word 			uint16_t
+#define NOMEM 			0
+#define MEM 			1
+#define NOINIT			__attribute__ ((section (".noinit")))
+#define STROBE  		253
+#define BEACON			252
+#define MODES_0			NOMEM,	255, 0 , 0, 0 , 0			// Fill unused modes with pwm level 0
+#define MODES_1			MEM,	25,	255 , 0 , 0 , 0
+#define MODES_2			NOMEM,	25,	255 , 0 , 0 , 0
+#define MODES_3			MEM, 	255, 25 , 0 , 0 , 0
+#define MODES_4			NOMEM, 	255, 25 , 0 , 0 , 0
+#define MODES_5			MEM,	25, 64 , 255 , 0 , 0
+#define MODES_6			NOMEM,	25, 64 , 255 , 0 , 0
+#define MODES_7			MEM,	255, 64 , 25 , 0 , 0
+#define MODES_8			NOMEM,	255, 64 , 25 , 0 , 0
+#define MODES_9			NOMEM,	6, 25 , 64 , 255 , 0
+#define MODES_10		NOMEM,	25, 64 , 255 , STROBE , 0
+#define MODES_11		NOMEM,	6 , 25 , 64 ,BEACON, STROBE
+#define LENGTH_MODES	6									// 5 modes per group +1 for memory seletion
+#define NUM_GROUPS		12									// 12 groups
+PROGMEM const byte groups[NUM_GROUPS][LENGTH_MODES]={	
+							{MODES_0} , {MODES_1} ,	//delete or add groups here
+							{MODES_2} , {MODES_3} ,
+							{MODES_4} , {MODES_5} ,
+							{MODES_6} , {MODES_7} ,
+							{MODES_8} , {MODES_9} ,
+							{MODES_10}, {MODES_11} };
+
+#define RESETTIME 12
+#define BATTMON  129
+
+#define outpin 1
+#define PWM OCR0B
+#define adcpin 2
+#define adcchn 1
+#define portinit() do{ DDRB=(1<<outpin); PORTB=0xff-(1<<outpin)-(1<<adcpin);  }while(0)
+
+#define WDTIME 0b01000011  //125ms
+
+#define sleepinit() do{ WDTCR=WDTIME; sei(); MCUCR=(MCUCR &~0b00111000)|0b00100000; }while(0)
+
+#define SLEEP asm volatile ("SLEEP")
+
+#define pwminit() do{ TCCR0A=0b00100001; TCCR0B=0b00000001; }while(0)
+
+#define adcinit() do{ ADMUX =0b01100000|adcchn; ADCSRA=0b11000100; }while(0)
+#define adcread() do{ ADCSRA|=64; while (ADCSRA&64); }while(0)
+#define adcresult ADCH
+
+#define ADCoff ADCSRA&=~(1<<7)
+#define ADCon  ADCSRA|=(1<<7)
+#define ACoff  ACSR|=(1<<7)
+#define ACon   ACSR&=~(1<<7)
+
+
+EEMEM byte eemode = 1;				//Saving mode and group in EEPROM, no wear leveling
+EEMEM byte eegroup = 1;
+byte mypwm = 0;
+volatile byte ticks = 0;
+byte mode = 1;
+byte pmode = 50;
+byte group= 0 ;
+byte memory = 0;
+byte i = 0;
+byte decay NOINIT;					//Using the NOINIT section of the RAM
+byte shortcounter NOINIT;
+byte lowbattcounter = 0;
+
+ISR(WDT_vect) {
+	if (ticks < 255)
+		ticks++;
+	if (ticks == RESETTIME)
+		shortcounter=0;  			// Setting back the counter for repeated shortpresses, so we
+									// never enter programming mode by accident
+
+
+#ifdef BATTMON
+	adcread()
+	;
+	if (adcresult < BATTMON) {
+		if (++lowbattcounter > 40) {
+			mypwm = (mypwm >> 1) + 3;
+			lowbattcounter = 0;
+		}
+	} else
+		lowbattcounter = 0;
+#endif
+}
+
+
+void _delay_ms(uint16_t n) {
+
+    while(n-- > 0) _delay_loop_2(950);
+}
+
+
+inline void getmode(void) {
+
+	mode=eeprom_read_byte(&eemode);						//reading mode and group from EEPROM
+	group=eeprom_read_byte(&eegroup);
+	memory=pgm_read_byte(&groups[group][0]);			// reading memory from the 2D-array stored in flash
+	if (!decay) {										// fast press
+		mode++;
+									//wrap around if it is last mode of the group or a unused mode
+	    if ((mode > LENGTH_MODES) || (!(pgm_read_byte(&groups[group][mode]))))
+	    	mode = 1;
+
+	    	shortcounter += 1;							//count number of short-presses
+		}
+		else {											// long press
+			if (memory == NOMEM) {
+	  		  mode=1;  //NOMEM
+
+		}
+	  	shortcounter = 0;								//Set back the counter for repeated shortpresses
+		}
+	  decay=0;											//Set back decay for long/shortpress detection
+
+	  eeprom_write_byte(&eemode, mode);
+}
+
+
+int main(void) {
+
+
+	portinit();
+
+	sleepinit();
+
+	ACoff;
+
+#ifdef BATTMON
+	adcinit();
+#else
+	ADCoff;
+#endif
+
+	pwminit();
+
+	getmode();
+
+	pmode= pgm_read_byte(&groups[group][mode]);
+
+	if (shortcounter>15) {								// 15 or more short presses, enter programming mode
+
+		PWM = 25;
+		_delay_ms(2000);								// to switch to the next group, press switch when light
+		shortcounter = 0;								// goes off after 2sec, or wait until it turn on again to cancel
+														// switching the group
+		group++;
+		if (group >= NUM_GROUPS)
+			group = 0;
+		shortcounter = 0;
+		eeprom_write_byte(&eegroup, group);
+		eeprom_write_byte(&eemode, 1);
+		PWM = 0;
+		_delay_ms(2000);
+		if (!group)
+			group--;
+		else
+			group = (NUM_GROUPS-1);
+		eeprom_write_byte(&eegroup, group);
+		while (1) {
+			PWM = 25;
+		}
+
+		}
+
+	else {
+
+			switch (pmode) {
+
+		#ifdef STROBE
+			case STROBE:
+				mypwm = 255;
+				while (1) {
+					PWM = mypwm;
+					_delay_ms(20);
+					PWM = 0;
+					_delay_ms(60);
+				}
+				break; //strobe 12.5Hz  //+48
+		#endif
+
+		#ifdef BEACON
+			case BEACON:
+		#ifdef BATTMON
+
+				adcread();
+				i = adcresult;
+				while (i > BATTMON) {
+					PWM = 8;
+					SLEEP;					//SLEEP instead of delay_ms saves a few bytes here
+					SLEEP;
+					SLEEP;
+					PWM = 0;
+					SLEEP;
+					SLEEP;
+					i -= 5;
+				}
+				SLEEP;
+				SLEEP;
+				SLEEP;
+		#endif
+				mypwm = 255;
+				while (1) {
+					PWM = mypwm;
+					_delay_ms(20);
+					PWM = 0;
+					_delay_ms(9880);
+				}
+				break;  //beacon 10s //+48
+		#endif
+
+			default:
+				mypwm = pmode;
+				while (1) {
+					PWM = mypwm;
+					SLEEP;
+				}
+			}
+}
+		return 0;
+}
\ No newline at end of file

=== added file 'odd/MGdriver/MGdriver.hex'
--- odd/MGdriver/MGdriver.hex	1970-01-01 00:00:00 +0000
+++ odd/MGdriver/MGdriver.hex	2015-07-18 20:54:25 +0000
@@ -0,0 +1,52 @@
+:020000000101FC
+:100000002DC045C044C043C042C041C040C03FC0F5
+:100010003FC03DC000FF000000000119FF000000CC
+:100020000019FF00000001FF1900000000FF190087
+:100030000000011940FF0000001940FF000001FF0F
+:100040004019000000FF4019000000061940FF00A1
+:10005000001940FFFD0000061940FCFD11241FBEE1
+:10006000CFE9CDBF10E0A0E6B0E0EAE0F3E002C0E7
+:1000700005900D92A236B107D9F710E0A2E6B0E0E4
+:1000800001C01D92A836B107E1F73BD03CC1B8CF03
+:100090001F920F920FB60F9211248F9380916600DA
+:1000A0008F3F29F0809166008F5F8093660080917A
+:1000B00066008C3011F410926800369A3699FECFA3
+:1000C00085B1813868F4809162008F5F809362000F
+:1000D000893240F08091670086958D5F809367003C
+:1000E000109262008F910F900FBE0F901F90189585
+:1000F00026EB33E003C0F9013197F1F70197D8F708
+:10010000089582E087BB89EF88BB83E481BD789442
+:1001100085B7877C806285BF479A81E687B984EC82
+:1001200086B981E28FBDC1E0C3BF81E090E0D5D048
+:10013000D82F8093610080E090E0CFD0382F80935B
+:10014000650090E066E070E0B6D0FC01EC5EFF4F29
+:10015000E491E09364008091690081111DC02D2F0E
+:100160002F5F273080F4832F90E066E070E0A3D00B
+:10017000FC01E20FF11DEC5EFF4FE491EE2319F05C
+:100180002093610003C081E080936100809168004A
+:100190008F5F8093680006C0E11102C0C0936100C8
+:1001A00010926800109269006091610081E090E017
+:1001B0009CD0209161008091650090E066E070E045
+:1001C0007AD0820F911D8C5E9F4FFC0184918093A9
+:1001D000600090916800903170F189E189BD80EDF7
+:1001E00097E086DF10926800809165008F5F8093B2
+:1001F00065008C3010F0109265006091650080E021
+:1002000090E073D061E081E090E06FD019BC80EDA8
+:1002100097E06EDF80916500811102C08FEF01C011
+:100220008BE0809365006091650080E090E05DD098
+:1002300089E189BDFECF8C3F81F08D3FA9F58FEF1D
+:10024000809367008091670089BD84E190E050DF72
+:1002500019BC8CE390E04CDFF5CF369A3699FECF8F
+:1002600085B18093630098E00AC099BD8895889510
+:10027000889519BC889588958550809363008091F6
+:100280006300823890F78895889588958FEF8093E2
+:1002900067008091670089BD84E190E029DF19BC87
+:1002A00088E996E225DFF5CF8093670080916700AB
+:1002B00089BD8895FBCF5527002480FF02C0060E1C
+:1002C000571F660F771F6115710521F09695879569
+:1002D000009799F7952F802D0895E199FECF1FBAC9
+:1002E0008EBBE09A99278DB30895262FE199FECF12
+:1002F0001CBA1FBA8EBB2DBB0FB6F894E29AE19AD6
+:0A0300000FBE01960895F894FFCF98
+:02030A003201BE
+:00000001FF

=== added file 'odd/MGdriver/meta'
--- odd/MGdriver/meta	1970-01-01 00:00:00 +0000
+++ odd/MGdriver/meta	2015-07-18 20:54:25 +0000
@@ -0,0 +1,14 @@
+Description: Off-time multigroup driver by odd, based on luxdrv030 by DrJones
+     Main differences to luxdrvß30:
+     - REMOVED: Ramping mode
+     - REMOVED: Wear leveling
+     - CHANGED: OFFTime memory instead of ONTime memory
+     - ADDED: Multiple groups
+     - ADDED: Memory or nomemory selectable for each group
+     - ADDED: Simple UI for switching groups
+Authors: odd, DrJones
+MCU: attiny13a
+Button-Type: clicky
+Memory: offtime, none
+Modes: beacon, strobe
+Extras: mode groups

